//+------------------------------------------------------------------+
//|                                                   Invertor.mq5 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <Trade\Trade.mqh> 
#include <..\Experts\CPanel.mq5>

input double    Lot            =1;
input double    TakeProfit     =100;
input double    StopLoss       =100;

int TP;
int SL;

CTrade trader;

bool Invertor = true;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
    GetPositionProperties();
    TP = TakeProfit;
    SL = StopLoss;
    
    if (_Digits == 3 || _Digits == 5)
    {
        TP *=1;
        SL *=1;
    }

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
    DeleteInfoPanel();
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
    GetPositionProperties();
    double points;
    
    if (!PositionSelect(_Symbol))
    {
        if (Invertor)
           trader.Buy(Lot);
        else trader.Sell(Lot);
    }
    else
    {
        if (PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
        {
               points = (SymbolInfoDouble(_Symbol, SYMBOL_BID) - PositionGetDouble(POSITION_PRICE_OPEN))/_Point;
               if (points >= TP)
               {
                   trader.PositionClose(_Symbol);
                   Invertor = true;
               }
        
               if (points <= -SL)
               {
                   trader.PositionClose(_Symbol);
                   Invertor = false;
               }
        }
         
        if (PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL)
        {
               points = (PositionGetDouble(POSITION_PRICE_OPEN) - SymbolInfoDouble(_Symbol, SYMBOL_ASK))/_Point;
               if (points >= TP)
               {
                   trader.PositionClose(_Symbol);
                   Invertor = false;      
               }
               
               if (points <= -SL)
               {
                   trader.PositionClose(_Symbol);
                   Invertor = true;
               }
        }
    }        
} 
//+------------------------------------------------------------------+
